
// Plotprogramm
version=20070202;

   printf('\n\n\n   Zeitfunktion aus WAV-File anzeigen \n   Version %i \n',version);
   printf('   G. Heinz GFaI \n\n\n');



// F U N K T I O N E N

        // Offsetbefreiung
        // Die Funktion setzt AC-versetzte Zeitfunktionen wieder auf die Nullinie.
        // Dazu wird angenommen, da die Zeitfunktion innerhalb eines greren, 
        // sortierten Bereiches delta konstant mit Abweichung epsilon ist.
        
        function [out]=nullo(in)  // length(in) muss viel grer als deltat sein.
                    deltat=98;
                    i=1;
                    n=length(in);
                        if n <= 3*deltat then printf('Warning: length(in)=%i < 3*deltat=%i in function nullo');
                        end;
                    eps=99;

                    ort=0;
                    insort=sort(in);          // Zeitfunktion sortieren
                     // clf;plot(insort);plot(in);
                      for i=1:(n-deltat) do;
                        delta=insort(i)-insort(i+deltat);
                          if delta < eps then;  // suche nach Ort des minimalen Abstiegs
                          eps=delta; ort=i;
                          end;
                        nullpunkt=insort(ort);     // hier ist unser gesuchter Nullpunkt
                      end;
                    [out] = (in)-nullpunkt;   // verschieben der Zeitfunktion
                     printf('ort=%i nullpunkt=%i n=%i \n\n',ort,nullpunkt,n); 
                     // plot(out);
        endfunction;
        
        
        // Funktionswerte boolesch negieren (Range 0:1)
        function [out]=neg(in);
            in=-in;
            [out]=(in)+1;
        endfunction;


        // Normieren auf 0:1 incl. Negation
        function [out]=normi(in)
                    [in]=nullo(in);   // Null offset
                    maxw = max(in);   // Min oder Max suchen?
                    minw = min(in);
                    printf('maxw=%i, minw=%i \n', maxw, minw);
                      if maxw > -minw then
                          maxw=1/maxw;
                          [out] = (in)*maxw;   //
                          else
                          minw=1/minw;
                          [out] = (in)*minw;   //
                      end;
        endfunction;
// Ende Funktionen.




// wav-File einlesen:
   filepath=xgetfile('*.wav',title='Select a WAV-file');
   [y,Fs,bits]=wavread(filepath); //Fs integer; bits integer;
   directory=dirname(filepath);    
   wavname=basename(filepath);

// Parameter anzeigen:
   printf('\nSample rate %i Hz, ',Fs);
   printf(' %i Bit/Sample \n\n',bits);
//   printf('CWD: %s\n',filepath);

// eindim. Vektor erzeugen, falls Stereo:
   zeitfkt=y(:,1); //erste Spalte, Stereo auf Mono plotten, falls.
   zlenge=length(zeitfkt);
   printf('Gesamtlnge der Zeitfunktion \t= %i Samples \n',zlenge);

// Plottbereich-Dialog:
   start=evstr(x_dialog('Start (Sample)?','90000'));
   delta=evstr(x_dialog('Dauer (Samples)?','1000'));

// Vektor zurechtschneiden:
   stop=start+delta-1;      // sonst sieht Plot nicht gut aus
   brennphase=zeitfkt(start:stop);

// Dialog normieren:
   norma=evstr(x_dialog('Zeitfunktion normieren? (ja=1)','1'));

// Dialog Bildschirme lschen:
   loesch=evstr(x_dialog('Bildschirme lschen? (ja=1)','1'));
   if loesch==1 then; clf(0); clf(1); end;   

// wav-File abspielen:   
   play=evstr(x_dialog('Wav abspielen? (ja=1)','0'));
   if play==1 then; playsnd(y); end;   
 


// Plot roh
    scf(0);    // set the current graphic window to #0
    plot2d(brennphase); 
    xtitle('Rohdaten '+wavname+'.wav','n','y');
//    halt;

// nur fr den logfile:
   printf('Start des Brennausschnitts \t= %i \n',start);
   blenge=length(brennphase);
   printf('Lnge des Brennausschnitts \t= %i \n\n\n',blenge);

//   who_user();  //Benutzte Parameter


// Plot normiert
   scf(1);    // set the current graphic window to #1
   if norma==1 then; brennphase=normi(brennphase); end;   
   plot2d(brennphase); 
   xtitle('Normiert '+wavname+'.wav','n','y');



